/*-------------------------------*/
/* Provided by Nancy McCracken   */
/*-------------------------------*/
#include	<stdio.h>
#include	<mpi.h>

/* Set up communication tags (these can be anything) */
#define to_right 201
#define to_left  102

void main (int argc, char *argv[]) {
int ierror, procnum, my_procnum, numprocs;
int right, left, other, sum, i;

MPI_Status  recv_status;

    MPI_Init(&argc, &argv);

    MPI_Comm_rank(MPI_COMM_WORLD, &my_procnum);
    MPI_Comm_size(MPI_COMM_WORLD, &numprocs);

    right = my_procnum + 1;
    if (right == numprocs) right = 0;

    left = my_procnum - 1;
    if (left == -1) left = numprocs-1;

    sum = 0;
    procnum = my_procnum;

    for( i = 0; i < numprocs; i++) {

        MPI_Send(&procnum, 1, MPI_INT, right, to_right,
                   MPI_COMM_WORLD);
    
        MPI_Recv(&other, 1, MPI_INT, left, to_right,
                 MPI_COMM_WORLD, &recv_status);
    
        sum = sum + other;
        procnum = other;
    
    }

    printf ("PE%d:\tSum = %d\n", procnum, sum);

    MPI_Finalize();

}
