#include <stdio.h>
#include <mpi.h>
#define N 22   /* total size of data */
#define P 4    /* each processor has P + rank data items in the array */

void main(int argc, char *argv[])
{
   int size;  /* Number of processors */
   int rank;   /* Processor number */
   int i,sum;

   int testmatrix[N];
   int count, countvect[P], dispvect[P];

   MPI_Init(&argc, &argv);

   MPI_Comm_rank(MPI_COMM_WORLD, &rank);

   MPI_Comm_size(MPI_COMM_WORLD, &size);

   printf ("Hello from processor %d out of %d\n", rank, size);
   
/* all processors initialize count and disp variables */
   count = rank + P;
   sum = 0;
   for (i=0; i<P; i++) 
     { countvect[i] = i+P;  dispvect[i] = sum;  sum = sum + i+P; };

/*  each processor initializes its data area */
   for (i=dispvect[rank]; i<dispvect[rank]+count; i++)
     testmatrix[i] = rank;

/*  all data areas are gathered into the entire matrix */

   MPI_Allgatherv (&testmatrix[dispvect[rank]], count, MPI_INT,
             testmatrix, countvect, dispvect, MPI_INT, MPI_COMM_WORLD);

/*  all processors print entire matrix */

   for (i=0; i<N; i++)  printf(" %d", testmatrix[i]);
   
   MPI_Finalize();

}


