/* Copyright 1997 Lucent Technologies Inc. - All Rights Reserved */

#include "librand/sha.h"

#define PROTOVER	1

#define HASHLEN	SHALEN
#define KEYLEN	HASHLEN

#define MAXSERVICENAME	256
#define MAXIO		(0x7fff)

#define ERRSTR	"remote reported an error:"	/*message escape for errors*/

#ifndef	KEYDIR
#define	KEYDIR "/usr/local/etc/keys"
#endif

typedef	 unsigned long long	u_llong;

extern char *sslname;
extern int debug;

#define C_ERROR		(-1)
#define C_EOF		(-2)
#define C_CORRUPTED	(-6)	/* error code for corrupted read */

typedef unsigned char	KEY[KEYLEN];
typedef unsigned char	DIGEST[HASHLEN];

/*
 * hmac stuff
 */
typedef struct hmac_ctx	hmac_ctx;
struct hmac_ctx {
	DIGEST_CTX context;
	unsigned char k_ipad[65];     /* inner padding - key XORd with ipad */
	unsigned char k_opad[65];     /* outer padding - key XORd with opad */
};

/* hmac.c */
extern	void hmac_init(hmac_ctx *context, u_char *key, int key_len);
extern	void hmac_update(hmac_ctx *context, u_char *text, int text_len);
extern	void hmac_final(hmac_ctx *context, u_char *digest);
extern	void hmac_sha(u_char *, int, u_char *, int, u_char *);

/* in crypto.c */
extern	KEY	read_key;
extern	KEY	write_key;
extern	u_llong	read_seq;
extern	u_llong	write_seq;
extern	char protohead[];
extern	int headlen;

extern	void make_challenge(u_char *);
extern	void chal_to_key(u_char *, u_char *, u_char *, u_char *);
extern	char *readkey(char *fn, u_char *key);
extern	char *proto_setup_read(int fd, void *msg, int n);
extern	char *proto_setup_write(int fd, void *msg, int n);

/* in crypto_client.c */
extern	char *start_client_crypto(int fd, u_char *key, char *servicename);

/* in crypto_server.c */
extern	char *start_server_crypto(int fd);

/* in librand */
extern	unsigned long trand8();

/* caller supplied */
extern	char *setservice(char *name, u_char *key);

/* in ssl.c */
extern	int sslread(int fd, void *obuf, int blen);
extern	int sslwrite(int fd, void *ibuf, int len);
extern	char sslerror[];
extern	void sslperror(char *msg);

#define cread(fd, buf, len)	sslread(fd, buf, len)
#define cwrite(fd, buf, len)	sslwrite(fd, buf, len)
#define cperror(buf)		sslperror(buf)
#define cerror			sslerror
