/* Copyright 1997 Lucent Technologies Inc. - All Rights Reserved */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#include "u.h"
#include "crypto.h"

static char err[BUFSIZ];

/*
 * Set up an authenticated session with the caller.
 */
char *
start_server_crypto(int fd) {
	char msg[MAXSERVICENAME+1+sizeof(KEY)];
	int n;
	char *ep;

	n = cread(fd, msg, sizeof(msg));
	if (n <= 0) {
		sprintf(err, "%s initial read error - %s",
			ERRSTR, cerror);
		cwrite(fd, err, strlen(err)+1);
		return &err[sizeof(ERRSTR)];
	}

	if (strchr(msg, "/") != 0) {
		sprintf(err, "%s illegal service name - %s",
			ERRSTR, msg);
		cwrite(fd, err, strlen(err)+1);
		return &err[sizeof(ERRSTR)];
	}

	if ((ep=setservice(msg, key)) != 0) {
		sprintf(err, "%s %s", ERRSTR, ep);
		sslwrite(fd, err, strlen(err)+1);
		return ep;
	}
	cwrite(fd, "OK", 3);
	return 0;
}
