#!/bin/sh
#
#	staged end of the test.

PATH=.:$PATH
export PATH

SLAVE=/var/tmp/stage.slave
UID=`grep "^$LOGNAME:" /etc/passwd | cut -d: -f3`
GID=`grep "^$LOGNAME:" /etc/passwd | cut -d: -f4`


case "$#" in
1)	PREFIX=$1;;
0)	PREFIX=990;;
*)	echo "usage: teststage.sh [base-port]";;
esac

#case `whoami` in
#root) ;;
#*)	echo "$0: must be run as root (we need access to chroot)"
#	exit
#esac

DEBUG="-U -v "

umask 0000

echo "stage_test	$SLAVE	$UID,$GID	0007,0600" >test/staged.conf
echo "unstage_test	$SLAVE	$UID	r" >>test/staged.conf

test -d test/keys ||	(mkdir test/keys; chmod 777 test/keys)
test -f test/keys/stage_test || (
	./makekey >test/keys/stage_test
	chmod 444 test/keys/stage_test
)
test -f test/keys/unstage_test || (
	./makekey >test/keys/unstage_test
	chmod 444 test/keys/unstage_test
)

rm -rf $SLAVE
mkdir $SLAVE

for port in 0 1 2 3 4 5 6 7 8 9
do
	./staged -c test/staged.conf -d $DEBUG -p $PREFIX$port -k test/keys || exit
	echo
done

echo "Staged test complete, apparently OK"
