/*
 * This is the table for the performance measurements,
 * containing message sizes in powers of 2.
 *
 * Volker Strumpen               Zurich, March 6, 1994
 *  modified slightly by Alan Edelman for 18.337 2/10/1997   
 */


#define MAXMSGSIZE   (1024*1024)
#define MTBLSIZE      21


struct meas {
   int size;  /* Size of message */
   int npp;   /* Number of ping-pongs to obtain accurate timings,
                 i.e., the amount of time needed for the experiment
                 to last longer than 10 times the timer resolution   */
} mtable [] = {
        1,      400,
        2,      400,
        4,      400,
        8,      400,
        16,     200,
        32,     200,
        64,     200,   /* 200 */
        128,    200,
        256,    200,
        512,    200,
        1024,   200,
        2048,   200,
        4096,   100,   /* 100 */
        8192,   100,
        16384,  50,
        32768,  20,
        65536,   10,
        131072,  10,
        262144,  5,
        524288,  5,
        1048576, 5
};



