#include "mpi.h"
#include <stdio.h>
#include <math.h>
#include "msgtbl.h"



int main(argc,argv)
int argc;
char *argv[];
{
   int             myid, numprocs, i, j;
   double          startwtime, mytime;
   int             namelen;
   char            processor_name[MPI_MAX_PROCESSOR_NAME];
   unsigned char   buf[MAXMSGSIZE];
   MPI_Status      msgstatus;

   MPI_Init(&argc, &argv);
   MPI_Comm_size(MPI_COMM_WORLD, &numprocs);
   if (numprocs != 2) {
      fprintf(stderr, "\n Error: number of processes must be 2!\n");
      exit(-1);
   }
   MPI_Comm_rank(MPI_COMM_WORLD, &myid);
   MPI_Get_processor_name(processor_name, &namelen);
   printf("Process %d on %s\n", myid, processor_name);

   if (myid == 0) {

      printf ("\n  Volume [bytes]  Transfertime [ms]  Throughput [Mbit/s]\n");

      for (i=0; i<MTBLSIZE; i++) {
         startwtime = MPI_Wtime();

         for (j=0; j<mtable[i].npp; j++) {

            MPI_Send((void *) buf, mtable[i].size, MPI_CHAR, 1, 99, MPI_COMM_WORLD);
            MPI_Recv((void *) buf, mtable[i].size, MPI_CHAR, 1, 99, MPI_COMM_WORLD, &msgstatus);

         }

         mytime = MPI_Wtime() - startwtime;
         printf("\n %10d        %12.6f          %10.6f", mtable[i].size,
                mytime*1.e3/(2.0*mtable[i].npp),
                mtable[i].size*16.0*mtable[i].npp/(1048576.*mytime));

      }
   }
   else {
      for (i=0; i<MTBLSIZE; i++) {
         for (j=0; j<mtable[i].npp; j++) {

            MPI_Recv((void *) buf, mtable[i].size, MPI_CHAR, 0, 99, MPI_COMM_WORLD, &msgstatus);
            MPI_Send((void *) buf, mtable[i].size, MPI_CHAR, 0, 99, MPI_COMM_WORLD);
         }
      }
   }

   MPI_Finalize();
   return 0;
}

            


