#!/usr/local/bin/perl

#*------------------------------------------------*
#* COPYRIGHT (C) 1996, 1997, 1998                 *
#* Northeast Parallel Architectures Center        *
#*         Syracuse University                    *
#*------------------------------------------------*

#$Id$
#$Log$
#Author: Kivanc Dincer, NPAC 1996.
#Modified by: Erol Akarsu and Saleh Elmohamed, NPAC 1997, 1998.

require 'query-string.pl';
require 'html-util.pl';
require 'set-env.pl';
##$MPIHOME = "/usr/npac/mpich/bin/";
$MPICOMPILE = "/opt/SUNWspro/bin/";
$MPIHOME = "/sunhpc/SUNWhpc/bin/";
$JAVAHOME = "/usr/npac/jdk1.1.4/bin/";
$MPIJAVALIB = "/usr/npac/MPIjava/src";

#>-----------------------------------------------------------------<
#> Function    : prints out an ascii file's contents onto stdout.
#> In Arguments: file's name ($FName)
#> Side Effect : on stdout.
#>-----------------------------------------------------------------<
sub Print_File{
   local($FName) = @_;
   open(InFile, $FName) || do htmlDie("Print_File:$!");
#   print "\n$FName:\n";
   while (<InFile>) {
      print $_;
   }
   close(InFile);
}

#>-----------------------------------------------------------------<
#> Function    : prints HTML page header for the monitor page.
#> In Arguments: none.
#> Side Effect : on stdout.
#>-----------------------------------------------------------------<
sub Print_Page_Header {
  print "Content-type: text/html\n\n";
  print "<HTML>\n";
  print "<HEAD>\n";
  print "<TITLE></TITLE>\n";
  print "</HEAD>\n";
  print '<BODY BGCOLOR="white" TEXT="black">';
  print "<FORM>";
  print '<CENTER>
         <H2><FONT COLOR="blue">Results of Submitted Process</H2> 
         </CENTER><HR></FONT>';
}

#>-----------------------------------------------------------------<
#> Function    : manages the HPF to F77+MP  translation by using Makefile.
#> In Arguments: names of the HPF and F77 files.
#> Side Effect : generates .f file.
#>-----------------------------------------------------------------<
sub DoCompile_byMake {    
   local($DemoDir, $targetF) = @_;
   local($cmnd); 
#>
#> Print information about the ongoing process.
#>
   $cmnd = "$targetF"; 
   print STDOUT "<i>Compiling: (make $cmnd) ...</i><BR>";
   print STDOUT "<TEXTAREA NAME=\"DISPLAY\" ROWS=\"10\" COLS=\"70\">";
   $stat = system("cd $DemoDir; $cmnd >compile.log  2>&1");
   $stat >>= 8;
   $stat = system("cd $DemoDir; make $cmnd");
   $stat >>= 8;
   print "\$stat is $stat and \$? is $? \n";
   &EndSwitchOut();
   
   do Print_File("stdout.dat");      
   do Print_File("stderr.dat");
   print "</TEXTAREA>";
   print "<HR>";
}

#>-----------------------------------------------------------------<
#> Function    : manages the execution process.
#> In Arguments: name of the target file and number of nodes required.
#> Side Effect : output is shown on an edit window.
#>-----------------------------------------------------------------<
sub DoExecute {
   local($numNodes, $DemoDir, $target, $inputF, $outputfile ) = @_;
   local($cmnd, $execfile);

   # ADDED BY EROL, Oct.7,13:09 PM.
   #---------------------------------------
   #$ENV{"CLASSPATH"} = "$ENV{'CLASSPATH'}:".$DemoDir.$dirname;
   #print "path : ".$ENV{"CLASSPATH"}."_endxx dirname=$dirname";
   #---------------------------------------

   print "<br><i>";

   #
   #$execfile = "$username-$target";
   $execfile = "$target"; 
   if ($numNodes eq 1) {$maxnodes = 1;} else {$maxnodes=4;}

   for ($i=1; $i<=$maxnodes; $i++) { 
      $cpcmnd = "/usr/ucb/rcp $DemoDir/$target osprey$i:/tmp/$execfile"; 
      $stat = system("cd $DemoDir; $cpcmnd >copy.log  2>&1");
   }
   #$cmnd = $MPIHOME."mpirun -np $numNodes /tmp/$execfile"; 
   $machines = $BinDir."machines";  
   #$cmnd = $MPIHOME."mpirun -machinefile $machines -np $numNodes $execfile"; 
   $cmnd = $MPIHOME."tmrun -np $numNodes $DemoDir/$execfile"; 
   #$cmnd = $MPIHOME."mpirun -np $numNodes $execfile"; 
   if ($compiler eq "F77") {
       print "Executing (Fortran 77+MPI) code ($cmnd) on $numNodes node in $DemoDir";
   }
   elsif ($compiler eq "C") {
       print "Executing (C+MPI) code ($cmnd) on $numNodes node";
   }
   #ADDED By EROL, Oct. 6, 1997, 11:30 pm.
   elsif ($compiler eq "Java"){
       print "Executing (Java+MPI) code ($cmnd) on $numNodes node";
   }
   elsif ($compiler eq "ad"){
       $cmnd = &executeAdlib($filename);
       print "Executing (Adlib) code ($cmnd) on $numNodes node";
   }

   print "s " unless ($numNodes == 1); 
   print "of the Sun Ultra Cluster ...";
   print " </i><BR>";
   print STDOUT "<TEXTAREA NAME=\"DISPLAY3\" ROWS=\"10\" COLS=\"60\"
          WRAP=\"VIRTUAL\">";
   
   $stat=system("limit cputime 10:00");
   $stat = system("cd $DemoDir; $cmnd >execute.log  2>&1");
   do Print_File("$DemoDir/execute.log");
##   if ($stat) {
##      print "Execution (i.e.,$cmnd) failed :-> \n $! \n";
##   }
##   else {
##      print "Execution completed successfully! \n";
##   }

   if ($outputfile) {
      #print "cp execute.log $dirname/$outputfile";
       $stat=system("cd $DemoDir; cp execute.log $dirname/$outputfile > cp.log 2>&1");
       if ($stat) {
	   print "\nOutput File could not be written!->\n $! \n";
       } 
   } 
   print "</TEXTAREA><HR noshade size=2> \n";
}

#Execute Adlib

sub executeAdlib{
   local ($adfile) = @_;
   local ($cmnd,$i,$adclass,$godir);
   $i = rindex($adfile,"/");
   if ($i< 0){
     $godir = "";
     $adclass = $adfile;
   }
   else{
     $godir = substr($adfile,0,$i);
     $adclass = substr($adfile,$i+1);
   }
   
   $ENV{"CLASSPATH"} = $DemoDir.$godir;
   $adclass = substr($adclass,0,index($adclass,"."));
   $cmnd = "prunjava -t $numNodes $adclass $ENV{'CLASSPATH'} ";
   
   print "ADLIB = $cmnd -path= X-$ENV{'CLASSPATH'}-X \n";
   return ($cmnd);
}

#>-----------------------------------------------------------------<
#> Function    : manages the C+MPI or F77+MPI compilation by using mpi scripts.
#> In Arguments: names of the C and F77 files in $files list,
#>               name of TARGET and name of user's lab directory.
#> Side Effect : generates .f file.
#>-----------------------------------------------------------------<
sub DoCompile_byCompiler {    
   local($ProgDir, $target, $files) = @_;

## Lots of things changed in Sept 3 and 4 by Erol and Saleh
##
   local($compile_fflags) = "-I/opt/SUNWhpc/include";  
   local($cflags) = "-DFORTRANUNDERSCORE -DHAVE_STDLIB_H=1 -g -I/opt/SUNWhpc/include  -DMPI_solaris $compile_fflags";

   local($fflags) = "-L/opt/SUNWhpc/lib -R/opt/SUNWhpc/lib -lmpi";
   
#   if ($compiler eq "F77") {
#       $cmnd .= $MPIHOME."mpif77 -o $target $files $flags";
#   } elsif ($compiler eq "C") {
#       $cmnd .= $MPIHOME."mpicc  -o $target $files $cflags"; 

   if ($compiler eq "F77") {
#	$cmnd .= $MPIHOME."f77 -g -w -c $compile_fflags $files;";
#	$i = rindex($files,"/");

#	if ($i >= 0){
#	   $files = substr($files,$i+1);
#	}
#	print "cmnd_1 = $cmnd";

#	$i = rindex($files,".");
#	$files = substr($files,0,$i).".o";
	
#	$cmnd .= $MPICOMPILE."f77 -g -w -o $target $files $fflags";
	$target = "cps615-mpi-f.exe";
      	$cmnd .= $MPICOMPILE."f77 -g -w $compile_fflags -o $target $files $fflags";
   } elsif ($compiler eq "C") {
       $target = "cps615-mpi-c.exe"; 
       $cmnd .= $MPICOMPILE."cc $compile_fflags -g -o $target $cflags -w $files $fflags -lm"; 
   }
   # ADDED BY EROL TO compile java applications, Oct. 7
   elsif ($compiler eq "Java") {
       $cmnd .= $JAVAHOME."javac $files";
       &Create_MPIjava_Script($files,$target);
   }
   elsif($compiler eq "ad"){
       $cmnd .= "adjavac $files";
   }
   else {
       &htmlDie("Compile: Wrong arguments cmnd=$cmnd.");
   }

   #out by Saleh Sep 2,1998
   #if ($compiler eq "C"){
   #  $cmnd = $cmnd." $LibDir"."scivis.so";
   #}  

   print "<i>Compiling: ($cmnd) ...</i><BR>";
   #$cmnd = "/npac/home/pcrc_hpf/mpi-scripts/" . $cmnd; 
   print STDOUT "<TEXTAREA NAME=\"DISPLAY3\" ROWS=\"10\" COLS=\"60\" 
         WRAP=\"VIRTUAL\">";

   $stat = system("cd $DemoDir; $cmnd >compile.log  2>&1");
   $stat >>= 8;

   do Print_File("$DemoDir/compile.log");
   if ($stat) {
      print "DEBUG: \$stat is $stat and \$? is $? \n";
      print "Exiting ... \n";
      print "</TEXTAREA>";
#      die; 
   }
   else {
      print "Compilation is successful! \n";
      print "</TEXTAREA>";
   } 
   print "<HR>";

}

sub Create_MPIjava_Script()
{
   local ($files,$target) =  @_;
   local ($godir,$i);

   $i = rindex($filename,"/");
   if ($i< 0){
     $godir = "";
   }
   else{
     $godir = substr($filename,0,$i);
   }

   #If there is more than java files to compile ,take first one which
   #has MAIN method...
   #----------------------------------------------------------------
   $in = index($files," ");
   if ($in >= 0){
     $files = substr($files,0,in);
   }
   $in = rindex($files,".");
   $javaClass = substr($files,0,$in);
   $in = rindex($javaClass, "/");
   $javaClass = substr($javaClass,$in+1); 
     
   $outFile = $DemoDir.$target;
   $curDir = $DemoDir.$godir.":$ENV{'CLASSPATH'}";
   print "CURDIR : $curDir \n";

   open(SCRIPT,">$outFile");
   print SCRIPT ("#!/usr/npac/bin/perl \n");
   print SCRIPT ("\$ENV{\"LD_LIBRARY_PATH\"}=\"$ENV{'LD_LIBRARY_PATH'} \";\n");
   #print SCRIPT ("\$ENV{\"CLASSPATH\"} = \"$ENV{'CLASSPATH'}\"; \n");
   print SCRIPT ("\$ENV{\"CLASSPATH\"} = \"$curDir\";\n");
   print SCRIPT ("\$params = join(\" \" ,\@ARGV) ;\n ");
   # print SCRIPT "\$cmnd = \"/home/R4D/hpjava/java/bin/java "."$javaClass "."\$0"." ". "\$params"." \"; \n";
   print SCRIPT "system(\$cmnd) ;\n";
   close(SCRIPT);
   chmod(0777,$outFile);
}


#>-----------------------------------------------------------------<
#> Function    : sets all flags and variables used in this script 
#>               according to user's selections.
#> In Arguments: $MY_DATA
#> Side Effect : All variables/flags given below are set.
#>-----------------------------------------------------------------<
sub Set_Compiler_Flags{
    local($i, $fldname);

    $numNodes      = $MYDATA{'MP_PROCS'};

    $compile       = ($MYDATA{'TASK.COMPILE'}) ? 1 : 0;
    $compiler      = $MYDATA{'COMPILER_TYPE'};
    $dirname      = $MYDATA{'FILENAME'};
    # $dirname = substr($dirname, 1, -1);
    $dirname = substr($dirname, 0, rindex($dirname,"/")); 
    $filename= $MYDATA{'FILENAME'};
    #$filename= substr($filename, rindex($filename,"/")+1,length($filename));
    $execute       = ($MYDATA{'TASK.RUN'})     ? 1 : 0;
    $executable_name= $MYDATA{'EXECUTABLE_NAME'};
    $inputfile     = $MYDATA{'INPUT_FILE'}; 
    $outputfile    = $MYDATA{'OUTPUT_FILE'};
    $ENV{"LM_LICENSE_FILE"} = "/usr/local/flexlm/licenses/license.dat";
    $ENV{"LD_LIBRARY_PATH"} = "/usr/npac/MPIjava/src";
    $ENV{"LD_LIBRARY_PATH"} = $LibDir.":$ENV{'LD_LIBRARY_PATH'}";
    $ENV{"LD_LIBRARY_PATH"} = "/project/kyk20/pcrc/zgs/Project/runtime/Adlib/src/adJava/adlib/".":$ENV{'LD_LIBRARY_PATH'}";
    $ENV{"CLASSPATH"} = "$BinDir".":"."$DemoDir";
    $ENV{"PATH"} = $BinDir.":$ENV{'PATH'}";
}
#>-----------------------------------------------------------------<
#> Function    : prints debugging statements.
#> In Arguments: chosen variables/flags of the script.
#> Side Effect : Chosen variables/flags are printed out.
#>-----------------------------------------------------------------<
sub Print_Debugging_Stmts {
    print "A few debugging stmts:";
    print "<blockquote>";

    print "directory: $DemoDir <br>";
    print "username: $username <br>";

    print "compile:  $compile <br>";
    print "execute:  $execute <br>";
    print "numNodes: $numNodes <br>";

    print "compiler: $compiler <BR>";
    print "filename: $filename <BR>";
    print "executable: $executable_name<BR>";

    print "MP_ variables: $numNodes <BR> ";
    print "inputfile:     $inputfile <BR>";
    print "outputfile:    $outputfile <BR>";

    print "</blockquote>";
    print "End of the debugging stmts<p>";
}

#
# -------------------- M A I N --------------------
#
   &Read_Query_String();
   &Parse_Query_String();
   &Define_Constants();

    &Print_Page_Header();
#>
#>- Set Compiler Flags   
#>
    &Set_Compiler_Flags();
#>
#> A few debugging stmts
#>
    #&Print_Debugging_Stmts();
    $targetFile = $executable_name;
    $ProgDir = $DemoDir . "/" . $dirname . "/";
   if ($compile) {
       #&DoCompile_byMake($DemoDir, $targetFile);
       &DoCompile_byCompiler($ProgDir, $targetFile, $filename);
   }

   if ($execute) {
           &DoExecute($numNodes, $DemoDir, $targetFile, 
                  $inputfile, $outputfile);
   }
print<<END;
<CENTER>
<SCRIPT>
<!-----
    document.write('<input type="button" value=" Close Window " onClick="parent.close(this)">');
//----->
</SCRIPT>
</CENTER>
END




  
   print "</BODY>\n";
   print "</HTML>\n";


