#!/usr/local/bin/perl
print "Content-type: text/plain\n\n";
require "set-env.pl";

#chdir("../htdocs/hpf");  
### set this environment variable #####
$pwd = `pwd`;
chop($pwd);

$ENV{"LD_LIBRARY_PATH"} = $wd.":$ENV{'LD_LIBRARY_PATH'}";
$ENV{"PGI"} = "/opt/PGI2.2";

&Define_Constants();
print "path = $ENV{'LD_LIBRARY_PATH'} \n";
#### take args :project_file_name and fortran files#####
###  and contsruct "project_file_name.prj" file which includes user files#####
###  and executable from these fortran files #################
########################################################

$argc = @ARGV;
$projectfile = $ARGV[0]; 
print "project file=$projectfile\n";


open (PROJECT,">$projectfile");
for($i=1;$i<$argc;$i++){
   $files[$i-1] = $ARGV[$i];
   print PROJECT "$files[$i-1]\n";
   print "file[$i] = $files[$i-1] argc=$argc\n"; 
}
close(PROJECT);

###cc -G -dy -K PIC -o ctoolbox.so rtlink.o debugger.o passivesock.o 
###update_comm.o ParToSerCopy.o

###### transform all the project files to .dep format #######
$depfiles = $projectfile.".prj";
open(DEPFILES,">$depfiles")||(&mydie("I can not create $depfiles "));
$index = 0;
foreach $onefile(@files){
    $cmnd="$FEBinDir"."hpf2dep ". "$DemoDir"."$onefile"." > $DemoDir"."error 2>&1";
    #$cmnd = "hpf2dep ".$onefile ." > errout 2>&1";
    print "In loop : $cmnd \n";
    $retval = system($cmnd);
    &printerror($retval,"I can not transform $onefile to .dep file");

    $depname = &depfilename($onefile);
    print DEPFILES "$depname\n";

    $hpffiles[$index]   = &hpffilename($onefile);
    $objfiles[$index] = &objfilename($onefile);
    $hpfdepfiles[$index] = &hpfdepfilename($hpffiles[$index]);
    $index++;
}
close(DEPFILES);

##### Do Instrumentation #####
$instrument_prog = "$ExecDir"."makeproje";
$cmnd = $instrument_prog ." ".$DemoDir.$projectfile ." > $DemoDir"."errout 2>&1";
print "$cmnd\n";
$retval = system($cmnd);
&printerror($retval,"Sorry I am facing the problem during instrumentation");


##### Compile .hpf file using PGI compiler #####
$k = @hpffiles;
print "lne = $k \n";
foreach (@hpffiles){
  $cmnd = "pghpf -Mfree -c ".$DemoDir.$_." > $DemoDir"."errout 2>&1";
  print "cmnd = $cmnd \n";
  $retval = system($cmnd);
  &printerror($retval,"Compilation error of instrumented codes ");
}

#### Now create executable from instrumented source codes and libraries#####
$execname = $DemoDir."demo_".$projectfile;
$cmnd = "pghpf -Mfree -o $execname ";
foreach (@objfiles){
    $cmnd = $cmnd . $DemoDir.$_." ";
}

$cmnd = $cmnd." ".$LibDir."ctoolbox.so ".$LibDir."liblexer.so ";
$cmnd = $cmnd.$LibDir."sagelib.so ".$LibDir."scivis.so ";
$cmnd = $cmnd ." -lsocket -lnsl -ll -ldl  -Xa -lpthread -lthread ";
$cmnd = $cmnd ." > $DemoDir"."errout 2>&1";
print "cmnd = $cmnd \n";
$retval = system($cmnd);
&printerror($retval,"I am facing problem during building executable file");


#### delete unnecessary object and .dep files #######
foreach (@objfiles){
    print "DELETE $_\n";
    $cmnd = "rm -fr ".$DemoDir.$_;
    system($cmnd);
}
foreach (@hpffiles){
     print "DELETE $_\n";
    $cmnd = "rm -fr ".$DemoDir.$_;
    system($cmnd);
}
foreach (@hpfdepfiles){
     print "DELETE $_\n";
    $cmnd = "rm -fr ".$DemoDir.$_;
    system($cmnd);
}
##############################################

sub printerror
{
    my ($retval,$errstring) = @_;
    if ($retval != 0){
      print "$errstring \n";
      open(ERROUT,"errout");
      @errlist = <ERROUT>;
      foreach $any(@errlist){
	 print "$any";
      }
      close(ERROUT);
      exit(2);
    }
}


sub depfilename{
    my ($filename) = @_;
    
    $i = index($filename,".");
    $temp = substr($filename,0,$i);
    
    $retval = $temp.".dep";
}

sub hpffilename{
    my ($filename) = @_;
    
    $i = index($filename,".");
    $temp = substr($filename,0,$i);
    $retval = "instrumented_".$temp.".hpf";
}

sub objfilename{
    my ($filename) = @_;
    
    $i = index($filename,".");
    $temp = substr($filename,0,$i);
    $retval = "instrumented_".$temp.".o";
}
sub hpfdepfilename{
    my ($filename) = @_;
    
    $i = rindex($filename,".");
    $temp = substr($filename,0,$i);
    $retval = $temp.".f.dep";
}

sub mydie{
    my ($msg) = @_;

    print "$msg \n";
    exit(1);
}
