/* Copyright 1997 Lucent Technologies Inc. - All Rights Reserved */

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <string.h>

#include "crypto.h"
#include "util.h"

char *
start_client_crypto(int fd, u_char *key, char *servicename) {
	char buf[100];
	char *cp, *ep;
	KEY c_chal, s_chal;
	int n = strlen(servicename);

	if (n > MAXSERVICENAME)
		return "Service name too long";

	/*
	 * Initial exchange has a key of zero.  
	 */
	memset(write_key, 0, sizeof(write_key));
	memset(read_key, 0, sizeof(read_key));
	read_seq = 0x4000000000000000LL;
	write_seq = 0;

	sprintf(protohead, "%c%d:", 'C', PROTOVER);
	headlen = strlen(protohead)+1;

	make_challenge(c_chal);
	strcpy(buf, servicename);
	memcpy(&buf[n+1], c_chal, sizeof(c_chal));
	if ((cp=proto_setup_write(fd, buf, n+1+sizeof(c_chal))) != 0)
		return cp;
	if ((ep=proto_setup_read(fd, s_chal, sizeof(KEY))) != 0)
		return ep;

	strcat(protohead, servicename);
	headlen = strlen(protohead)+1;

	/*
	 * Compute keys, and prove we know them.
	 */
	chal_to_key(c_chal, s_chal, key, read_key);
	chal_to_key(s_chal, c_chal, key, write_key);
	memset(key, 0, sizeof(KEY));	/* clear the secret */

	if ((cp=proto_setup_write(fd, "OK", 3)) != 0)
		return cp;
	if ((cp=proto_setup_read(fd, buf, 100)) != 0)
		return cp;

	if (strcmp(buf, "OK") != 0)
		return "secret keys don't match";
	return 0;
}
