#!/bin/sh
#
# run teststaged.sh first as root, then run this.

PATH=.:$PATH
export PATH

MASTER=/var/tmp/stage.master
SLAVE=/var/tmp/stage.slave
UNSLAVE=/var/tmp/unstage.slave

DEBUG=""
DEBUGU=""

case "$#" in
1)	PREFIX=$1;;
0)	PREFIX=990;;
*)	echo "usage: teststage.sh [base-port]";;
esac

BIG=""
for i in /unix /vmunix /bsd /bsd.generic /ufsboot
do
	if [ -r $i ]
	then
		BIG=$i
		break
	fi
done

case $BIG in
"")	echo Need a large test file, aborting
	exit;;
esac

rm -rf $MASTER
mkdir $MASTER
rm -rf $UNSLAVE
mkdir $UNSLAVE

echo "stage_test	localhost	$MASTER" >test/cserv.conf
echo "unstage_test	localhost	$UNSLAVE" >>test/cserv.conf

./stage -c test/cserv.conf $DEBUG -p ${PREFIX}0 -k test/keys/stage_test stage_test 
diff -r $MASTER $SLAVE || exit
sleep 2
./unstage -c test/cserv.conf $DEBUGU -p ${PREFIX}1 -k test/keys/unstage_test unstage_test 
diff -r $SLAVE $UNSLAVE || exit
sleep 2

echo file_a>$MASTER/file_a
chmod 444 $MASTER/file_a
mkdir $MASTER/dir_b
echo ba>$MASTER/dir_b/b_a
echo bb>$MASTER/dir_b/b_b
chmod 555 $MASTER/dir_b
echo test_c>$MASTER/test_c
mkdir $MASTER/dir_d
mkdir $MASTER/test_e

./stage -c test/cserv.conf $DEBUG -p ${PREFIX}2 -k test/keys/stage_test stage_test
diff -r $MASTER $SLAVE || exit
sleep 2
./unstage -c test/cserv.conf $DEBUGU -p ${PREFIX}3 -k test/keys/unstage_test unstage_test
diff -r $SLAVE $UNSLAVE || exit
sleep 2

# can we remove files and directories?

rm -f $MASTER/file_a
rmdir $MASTER/dir_d

# can we change a directory to a file?
rmdir $MASTER/test_e
echo test_e>$MASTER/test_e

# can we change a file to a directory?
rm $MASTER/test_c
mkdir $MASTER/test_c
echo test_c/a >$MASTER/test_c/a

# can we add to a directory?
chmod 755 $MASTER/dir_b
echo bc>$MASTER/dir_b/b_c
chmod 555 $MASTER/dir_b

./stage -c test/cserv.conf $DEBUG -p ${PREFIX}4 -k test/keys/stage_test stage_test
diff -r $MASTER $SLAVE || exit
sleep 2
./unstage -c test/cserv.conf $DEBUGU -p ${PREFIX}5 -k test/keys/unstage_test unstage_test
diff -r $SLAVE $UNSLAVE || exit
sleep 2

cp $BIG $MASTER/0
for i in 1 2 3 4 5 6 7 8 9
do
	ln $MASTER/0 $MASTER/$i || exit
done

./stage -c test/cserv.conf $DEBUG -p ${PREFIX}6 -k test/keys/stage_test stage_test
diff -r $MASTER $SLAVE || exit
sleep 2
./unstage -c test/cserv.conf $DEBUGU -p ${PREFIX}7 -k test/keys/unstage_test unstage_test
diff -r $SLAVE $UNSLAVE || exit
sleep 2

# remove everything

chmod 755 $MASTER/dir_b
rm -rf $MASTER/*

./stage -c test/cserv.conf $DEBUG -p ${PREFIX}8 -k test/keys/stage_test stage_test 
diff -r $MASTER $SLAVE
./unstage -c test/cserv.conf $DEBUGU -p ${PREFIX}9 -k test/keys/unstage_test unstage_test
diff -r $SLAVE $UNSLAVE || exit

sleep 1

rmdir $MASTER $UNSLAVE $SLAVE


echo "Stage test complete, apparently OK"
