      PROGRAM ASSIGN_3B

c     Assignment 3, Part 2
c
c*******************************************************************
c     Purpose:  Timing message sending/receiving with
c     messages of different sizes and different numbers of
c     processors.
c
c     Program will be run 9 times:
c          array length = 1, 1000, 100000 and
c          number processes (p) = 2, 4, 6 for each length.
c    
c     CPS615 - Spring 2000
c
c*******************************************************************

      IMPLICIT NONE

      INCLUDE "mpif.h"

      COMMON buffer(100000)

      REAL buffer

      INTEGER length, ierr, rank, p

      DOUBLE PRECISION start, finish, time

      CALL MPI_INIT(ierr)

      CALL MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)

      CALL MPI_COMM_SIZE(MPI_COMM_WORLD, p, ierr)

      start = MPI_WTIME()

      length = 1 

      IF (rank .EQ. 0) THEN

           CALL root(length)

      ELSE IF (rank .NE. 0) THEN

           CALL nonroot(length)

      ENDIF

      finish = MPI_WTIME()

      time = finish - start

      PRINT *, 'Message Length = ', length
      PRINT *, 'Process ', rank, ' out of ', p, ' processors.'
      PRINT *, 'Average Communication Time (out & in) = ', time/100.
      PRINT *, 'Bytes Moved Per Second = ', 
     $          REAL(2*p*4*100*length)/time
      PRINT *, ' '

      CALL MPI_FINALIZE(ierr)

      STOP

      END

c*******************************************************************

      SUBROUTINE root(count)

      IMPLICIT NONE

      INCLUDE "mpif.h"

      INTEGER count, ierr, rank, p, i, j

      INTEGER dest_oth, src_oth, tag

      INTEGER status(MPI_STATUS_SIZE)

      COMMON buffer(100000)

      REAL buffer

      tag = 101

      CALL MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)

      CALL MPI_COMM_SIZE(MPI_COMM_WORLD, p, ierr)

      DO j = 1, 100

           DO i = 1, p

                dest_oth = i

                CALL MPI_SSEND(buffer, count, MPI_REAL, dest_oth, tag,  
     $                         MPI_COMM_WORLD, ierr)

                src_oth = i

                CALL MPI_RECV(buffer, count, MPI_REAL, src_oth, tag,
     $                         MPI_COMM_WORLD, status, ierr)

           END DO

      END DO

      RETURN

      END

c*******************************************************************

      SUBROUTINE nonroot(count)

      IMPLICIT NONE

      INCLUDE "mpif.h"

      INTEGER ierr, rank, p, j

      INTEGER count, dest, source, tag

      INTEGER status(MPI_STATUS_SIZE)

      COMMON buffer(100000)

      REAL buffer

      tag = 101

      CALL MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)

      CALL MPI_COMM_SIZE(MPI_COMM_WORLD, p, ierr)

      DO j = 1, 100

           source = 0

           CALL MPI_RECV(buffer, count, MPI_REAL, source, tag,
     $                         MPI_COMM_WORLD, status, ierr)

           dest = 0

           CALL MPI_SSEND(buffer, count, MPI_REAL, dest, tag,  
     $                    MPI_COMM_WORLD, ierr)

      END DO

      RETURN

      END
