      PROGRAM ASSIGN_3C

c     Assignment 3, Part 3
c
c*******************************************************************
c     Purpose:  Use non-blocking send/receive between 
c     processors in a ring.  Each processor communicates 
c     with its neighbor on each side.
c
c     The problem will first be solved with blocking, then
c          with non-blocking.  Number of processors (p) will
c           include 2, 4, and 6.
c    
c     CPS615 - Spring 2000
c
c*******************************************************************

      IMPLICIT NONE

      INCLUDE "mpif.h"

      INTEGER ierr, rank, tag, p, i, type

      INTEGER mark(16), sum(16), dest, source
c 25
      INTEGER status(MPI_STATUS_SIZE), request

      DOUBLE PRECISION start, finish, time

      CALL MPI_INIT(ierr)

      CALL MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)

      CALL MPI_COMM_SIZE(MPI_COMM_WORLD, p, ierr)

      tag = 101

      start = MPI_WTIME()

      mark(rank) = rank

      sum(rank) = 0

c     PRINT *, 'Processor ', rank, ' original value is ', mark(rank)

      DO i = 1, p

              IF (rank .EQ. p-1) THEN

                     dest = 0
c50
              ELSE

                     dest = rank+1

              END IF


              CALL MPI_SEND(mark(rank), 1, MPI_INTEGER, dest,
     $        tag, MPI_COMM_WORLD, ierr)

              IF (rank .EQ. 0) THEN

                     source = p-1

              ELSE

                     source = rank-1

              ENDIF

              CALL MPI_IRECV(mark(source), 1, MPI_INTEGER,
     $               source, tag, MPI_COMM_WORLD, request, ierr)

              CALL MPI_WAIT(request, status, ierr)

              sum(rank) = sum(rank) + mark(source)

              mark(rank) = mark(source)

c             PRINT *, 'Processor ', rank, ' after pass number ', i

c             PRINT *, 'New value is ', mark(rank)

c             PRINT *, 'New sum is ', sum(rank)

      END DO

c     PRINT *, 'Processor ', rank, ' Final sum is ', sum(rank)
c 90
      finish = MPI_WTIME()

      time = finish - start

      PRINT *, 'Number of Processors = ', p
      PRINT *, 'Total Communication Time (sec) = ', time
      PRINT *, 'Time for each Pass (send & receive) by all 
     $           Processors = ', time/REAL(p)

      CALL MPI_FINALIZE(ierr)

      STOP

      END