      PROGRAM ASSIGN_3D

c     Assignment 3, Part 4, Number 1
c
c*******************************************************************
c     Purpose:  Use the broadcast function between 
c     multiple processors.  A root processor broadcasts 
c     a message and other processors return the message.
c
c     The program will be run with 2, 4, and 6 processors.
c    
c     CPS615 - Spring 2000
c
c*******************************************************************

      IMPLICIT NONE

      INCLUDE "mpif.h"

      INTEGER ierr, rank, tag, p, message

      INTEGER dest, source

      INTEGER status(MPI_STATUS_SIZE)

      DOUBLE PRECISION start, finish, time

      CALL MPI_INIT(ierr)

      CALL MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)

      CALL MPI_COMM_SIZE(MPI_COMM_WORLD, p, ierr)

      tag = 101

      start = MPI_WTIME()

      message = 111111

      IF (rank .EQ. 0) THEN

           message = 999999

      END IF

      PRINT *, 'Processor ', rank, ' original value is ', message

      CALL MPI_BCAST(message, 1, MPI_INTEGER, 0,
     $     MPI_COMM_WORLD, ierr)

      PRINT *, 'After Broadcast.'

      PRINT *, 'Processor ', rank, ' has message ', message

      IF (rank .NE. 0) THEN

           message = message - 222222

           CALL MPI_SSEND(message, 1, MPI_INTEGER, 0, tag,
     $          MPI_COMM_WORLD, ierr)

      ELSE

           DO source = 1, p-1

           CALL MPI_RECV(message, 1, MPI_INTEGER, source, tag,
     $     MPI_COMM_WORLD, status, ierr)

           PRINT *, 'Root received ', message, ' from processor ',
     $               source

           END DO

      ENDIF

      finish = MPI_WTIME()

      time = finish - start

      PRINT *, 'Number of Processors = ', p
      PRINT *, 'Total Communication Time (sec) = ', time
      PRINT *, 'Average Time for Send & Receive Per 
     $           Processor = ', time/REAL(p)

      CALL MPI_FINALIZE(ierr)

      STOP

      END