      PROGRAM ASSIGN_3D

c     Assignment 3, Part 4, Number 2
c
c*******************************************************************
c     Purpose:  Use the scatter and gather functions 
c     between multiple processors.  A root processor 
c     scatters a message and other processors return the pieces.
c
c     The program will be run with 2, 4, and 6 processors.
c    
c     CPS615 - Spring 2000
c
c*******************************************************************

      IMPLICIT NONE

      INCLUDE "mpif.h"

      INTEGER ierr, rank, tag, p, message(6), newmsg, lastmsg(6)

      INTEGER dest, source, i, j

      INTEGER status(MPI_STATUS_SIZE)

      DOUBLE PRECISION start, finish, time

      CALL MPI_INIT(ierr)

      CALL MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)

      CALL MPI_COMM_SIZE(MPI_COMM_WORLD, p, ierr)

      tag = 101

      start = MPI_WTIME()

      IF (rank .EQ. 0) THEN

           DO i = 1, 6

           message(i) = 2

           END DO

      ENDIF

      PRINT *, 'Processor ', rank, ' original array is ...'

      DO j = 1, p

      PRINT *, 'Position ', j, ' is ', message(j)

      END DO

      CALL MPI_SCATTER(message, 1, MPI_INTEGER, newmsg, 1,
     $     MPI_INTEGER, 0, MPI_COMM_WORLD, ierr)

      PRINT *, 'After Scatter.'

      PRINT *, 'Processor ', rank, ' has new message ', newmsg

      CALL MPI_GATHER(newmsg, 1, MPI_INTEGER, lastmsg, 1,
     $     MPI_INTEGER, 0, MPI_COMM_WORLD, ierr)

      PRINT *, 'After Gather.'

      PRINT *, 'Proc. ', rank, ' has a final message array of ...'

      DO j = 1, p

      PRINT *, 'Position ', j, ' is ', lastmsg(j)

      END DO

      finish = MPI_WTIME()

      time = finish - start

      PRINT *, 'Number of Processors = ', p
      PRINT *, 'Total Communication Time (sec) = ', time
      PRINT *, 'Average Time for Send & Receive Per 
     $           Processor = ', time/REAL(p)

      CALL MPI_FINALIZE(ierr)

      STOP

      END