c  ASSIGNMENT NO. 4 
c
c****************************************************************************
c
c  The assigned task was to execute an Nbody-type program that involves 
c  message passing and calculations with two arrays:  x(i) and y(j).
c
c  The general design of the program is suitable for common calculations 
c  between two arrays, such as those required for calculating correlation
c  coefficients.  However, the assignment is simplified by using the two 
c  arrays in a simple function:  f(a,b) = abs(a*a + b*b).
c
c****************************************************************************

      program ass4_par

      include "mpif.h"

c Define Variables.  

c Arrays Reserve Space for Up to 50 Records and 32 Processors.

c Z = f(X,Y)

      INTEGER Y(50), W(50), N, k, i, j, m
c 26
      REAL X(50), Z(50,50), SUBSUM(32), SUM

      INTEGER rank, p, tag, ierr, dest, source

      INTEGER status(MPI_STATUS_SIZE), request

      DOUBLE PRECISION start, finish, duration

      CALL MPI_INIT(ierr)

      CALL MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)

      CALL MPI_COMM_SIZE(MPI_COMM_WORLD, p, ierr)

      start = MPI_WTIME()

      tag = 101

c Hard-code Number of Records and Print

      N=12

      Print *, "Number of Records = ", N
c 50
c Open Input Files Containing X and Y Records

      OPEN (UNIT=11, FILE='par_input_x', FORM='FORMATTED',
     Z  ACCESS='DIRECT', RECL=8, STATUS='OLD')

      OPEN (UNIT=21, FILE='par_input_y', FORM='FORMATTED',
     Z  ACCESS='DIRECT', RECL=8, STATUS='OLD')

c Print the Number of Processors and the Number of Records per Processor

      Print *, "Number of Processors = ", p

      k = N/p

      Print *, "Number of Records per Processor = ", k

      Print *, ' '

c Read and Print Data Records for Each Processor

      Print *, "Processor ", rank, " starts with the following data."

      DO i = (rank*k)+1, (rank+1)*k
c 74
           READ (UNIT=11, FMT=10, REC=i) X(i)

 10        FORMAT (F5.1)

           READ (UNIT=21, FMT=20, REC=i) Y(i)

 20        FORMAT (I5)

           Print *, "Record Number = ", i, " X = ", X(i), " Y = ", Y(i)

      END DO

      Print *, ' '

c Compute function for all data pairs on each processor.  
c Summation on each processor is called SUBSUM. 

      SUBSUM(rank) = 0

      DO i = (rank*k)+1, (rank+1)*k

           DO j = (rank*k)+1, (rank+1)*k

                Z(i,j) = ABS(X(i)**2 + Y(j)**2)

                SUBSUM(rank) = SUBSUM(rank) + Z(i,j)

           END DO
c 100
      END DO

      Print *, "Processor ", rank, " starts with SUBSUM = ", 
     Z     SUBSUM(rank)

      Print *, ' '

c Convert Y-values to W-values with consistent indices to make
c passing between processors easier.

      i = 1

      DO j = (rank*k)+1, (rank+1)*k

           W(i) = Y(j)

c           Print *, "Processor ", rank, " has now established its ",
c     Z         j, "th Y-value as its ", i, "th W-value = ", W(i) 

           i = i+1

      END DO

c      Print *, ' '

      IF (rank .EQ. p-1) THEN

           dest = 0
c 126
      ELSE

           dest = rank+1

      END IF

      IF (rank .EQ. 0) THEN

           source = p-1

      ELSE

           source = rank-1

      END IF

c      Print *, ' '

      DO m = 1, p-1

           DO i = 1, k

                CALL MPI_SEND(W(i), 1, MPI_INTEGER, dest, 
     Z               tag, MPI_COMM_WORLD, ierr)
c 151
                CALL MPI_IRECV(W(i), 1, MPI_INTEGER, source,
     Z               tag, MPI_COMM_WORLD, request, ierr)

                CALL MPI_WAIT(request, status, ierr)

c                PRINT *, "Processor ", rank, " now has ",
c     Z                W(i), " as its ", i, "th W-value." 

           END DO

c           PRINT *, ' '

c Keep updating the function summation, SUBSUM, on each processor.

           DO i = (rank*k)+1, (rank+1)*k

                DO j = 1, k

                     Z(i,j) = ABS(X(i)**2 + W(j)**2)

                     SUBSUM(rank) = SUBSUM(rank) + Z(i,j)

                END DO

           END DO
c 175
      END DO

      Print *, "Processor ", rank, " ends with SUBSUM = ", 
     Z     SUBSUM(rank)

      Print *, ' '

c Collect and add the SUBSUM from each processor.

      CALL MPI_REDUCE(SUBSUM(rank), SUM, 1, MPI_REAL, MPI_SUM, 0,
     Z     MPI_COMM_WORLD, ierr)

      IF (rank .EQ. 0) THEN

           Print *, "Final Sum of All Products = ", SUM

      END IF

      Close (Unit=11) 

      Close (Unit=21)

      finish = MPI_WTIME()

      duration = finish - start

      PRINT *, ' '

      PRINT *, "Execution Time (sec) for Processor ", rank,
     Z  " = ", duration
c 200
      PRINT *, ' '

      CALL MPI_FINALIZE(ierr)

      end
