c  ASSIGNMENT NO. 4 
c
c****************************************************************************
c
c  The assigned task was to execute an Nbody-type program that involves 
c  message passing and calculations with two arrays:  x(i) and y(j).
c
c  The general design of the program is suitable for common calculations 
c  between two arrays, such as those required for calculating correlation
c  coefficients.  However, the assignment is simplified by using the two 
c  arrays in a simple function:  f(a,b) = abs(a*a + b*b).
c
c****************************************************************************

      program ass4_seq

      include "mpif.h"

      INTEGER Y(50), N, i

      REAL X(50), Z(50,50), SUM

      INTEGER my_rank, p, ierr

      INTEGER status(MPI_STATUS_SIZE)

      DOUBLE PRECISION start, finish, duration

      CALL MPI_INIT(ierr)

      start = MPI_WTIME()

      CALL MPI_COMM_RANK(MPI_COMM_WORLD, my_rank, ierr)

      CALL MPI_COMM_SIZE(MPI_COMM_WORLD, p, ierr)

c Define Variables.  Arrays Allow up to 50 Records.

c Open File "seq_input.dat." 

      OPEN (Unit=3, FILE='seq_input.dat', STATUS='OLD')
	
c Read the Number of Records (first line of data)

      Read (Unit=3, FMT=*) N

c Print the Number of Records

      Print *, N

c Read and Print Each Record from the Data File

      DO i = 1, N 
	
            Read (Unit=3, FMT=*) X(i), Y(i)

            Print *, X(i), Y(i)

      END DO

      SUM = 0

      DO i = 1, N 

            SUBSUM = 0

            DO j = 1, N
	
                 Z(i,j) = ABS(X(i)**2 + Y(j)**2)

                 SUBSUM = SUBSUM + Z(i,j)

                 Print *, i, j, Z(i,j), SUBSUM

            END DO

      SUM = SUM + SUBSUM

      PRINT *, i, j, SUM

      END DO

      Close (Unit=3) 

      finish = MPI_WTIME()

      duration = finish - start

      PRINT *, "Execution Time (sec) for ", p,
     z  " Processors = ", duration

      CALL MPI_FINALIZE(ierr)

      end
