/************************************************************************
 * Purpose:     Root broadcasts a message and all other processes send it
 *              back to root.. 
 *
 * Author:      Samir Mehta
 *
 ************************************************************************/
#include <stdio.h>
#include <mpi.h>

void main( int argc, char *argv[] )
{
     int ierr, rank, size, i;
     char message[20], new_message[20];
     MPI_Status status;

     ierr = MPI_Init(&argc, &argv);

     ierr = MPI_Comm_size(MPI_COMM_WORLD, &size);
     ierr = MPI_Comm_rank(MPI_COMM_WORLD, &rank);

     if(rank == 0)
     {
       strcpy(message, "Hello, world!");
       ierr = MPI_Bcast(message,14, MPI_CHAR, 0, MPI_COMM_WORLD);
       for(i=1;i<size;i++)
       {
          ierr = MPI_Recv(new_message, 14, MPI_CHAR, i, 100, MPI_COMM_WORLD, &status);
          printf("%s from %d\n",new_message, i);
       }
     }
     else
     {
       ierr = MPI_Recv(message, 14, MPI_CHAR, 0, 50, MPI_COMM_WORLD, &status);
       ierr = MPI_Send(message, 14, MPI_CHAR, 0, 100, MPI_COMM_WORLD);
     }
}
