/************************************************************************
 * Purpose:     This is a program designed to send a "ping" from processor
 *              0 to all the other processors, and receive a "pong"
 *              from the processors as a responce.  This process will be
 *              timed and the time recorded.
 *
 * Author:      Marjorie V. Quant
 *
 * Course:      CPS615 - Spring 2000
 *
 ************************************************************************/

#include <stdio.h>
#include <mpi.h>

#define ping 101
#define pong 101



void main ( int argc, char *argv[] )
 {
     int ierror, rank, p, length, i, k, l, n;
     double start, finish, total_time;
     MPI_Status status;
     int buffer[100000];

     MPI_Init(&argc, &argv);

     MPI_Comm_rank(MPI_COMM_WORLD, &rank);

     MPI_Comm_size(MPI_COMM_WORLD, &p); /* gets the # of processors */


     for (length = 1; length <=  100000; length += 1000)
      {


        if (rank == 0)
         {
          printf("Length\tTotal Time\tTransfer Rate\n");
          start = MPI_Wtime();

          for (k = 1; k < p; k++)
           {
            for (l=0; l<100; l++)
             {

               MPI_Send(buffer, length, MPI_INT, k, ping, MPI_COMM_WORLD);
               MPI_Recv(buffer, length, MPI_INT, k, pong, MPI_COMM_WORLD, &status);
             }/*end of l*/
            } 


          finish = MPI_Wtime();
          total_time = (finish - start);
          printf("%d\t %f\t \n", length, total_time);

         } /* end of if rank ==0 */

        /*  if rank is not 0, wait for a receive of ping from rank = 0,
        then send a pong to rank 0.  */

         else
         {
          for (n=0; n<p; n++)
          {
           if (rank == n)
           {
            for (l=0; l<100; l++)
            {
             MPI_Recv(buffer, length, MPI_INT, 0, ping, MPI_COMM_WORLD, &status);
             MPI_Send(buffer, length, MPI_INT, 0, pong, MPI_COMM_WORLD);
            } /*end of for l */
           }  /* end of if n */
          }   /* end of for n */
  
         }   /* end else */
     }  /* end of for length loop */



     MPI_Finalize();

} /* end of main */


