!
! Copyright (c) 1997, by Sun Microsystems, Inc.
! All rights reserved.
!
! (C) 1993 by Argonne National Laboratory and Mississipi State University.
!     All rights reserved.  See COPYRIGHT in top-level directory.
!
!
! User include file for Fortran MPI programs.
!

!
! MPI error codes.
!
       integer MPI_SUCCESS,MPI_ERR_BUFFER,MPI_ERR_COUNT,MPI_ERR_TYPE
       integer MPI_ERR_TAG,MPI_ERR_COMM,MPI_ERR_RANK,MPI_ERR_ROOT
       integer MPI_ERR_GROUP,MPI_ERR_OP,MPI_ERR_TOPOLOGY,MPI_ERR_DIMS
       integer MPI_ERR_ARG,MPI_ERR_UNKNOWN,MPI_ERR_TRUNCATE
       integer MPI_ERR_OTHER,MPI_ERR_INTERN,MPI_ERR_IN_STATUS
       integer MPI_ERR_PENDING,MPI_ERR_REQUEST,MPI_ERR_LASTCODE

       parameter(MPI_SUCCESS=0)
       parameter(MPI_ERR_BUFFER=1)
       parameter(MPI_ERR_COUNT=2)
       parameter(MPI_ERR_TYPE=3)
       parameter(MPI_ERR_TAG=4)
       parameter(MPI_ERR_COMM=5)
       parameter(MPI_ERR_RANK=6)
       parameter(MPI_ERR_ROOT=7)
       parameter(MPI_ERR_GROUP=8)
       parameter(MPI_ERR_OP=9)
       parameter(MPI_ERR_TOPOLOGY=10)
       parameter(MPI_ERR_DIMS=11)
       parameter(MPI_ERR_ARG=12)
       parameter(MPI_ERR_UNKNOWN=13)
       parameter(MPI_ERR_TRUNCATE=14)
       parameter(MPI_ERR_OTHER=15)
       parameter(MPI_ERR_INTERN=16)
       parameter(MPI_ERR_IN_STATUS=17)
       parameter(MPI_ERR_PENDING=18)
       parameter(MPI_ERR_REQUEST=19)
       parameter(MPI_ERR_LASTCODE=4114)
!
! Miscellaneous MPI constants.
!
       integer MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_PROC_NULL
       parameter(MPI_ANY_SOURCE=(-2))
       parameter (MPI_ANY_TAG=(-1))
       parameter(MPI_PROC_NULL=(-1))

       integer MPI_UNDEFINED
       parameter(MPI_UNDEFINED=(-32766))

       integer MPI_BSEND_OVERHEAD
       parameter(MPI_BSEND_OVERHEAD=512)

       integer MPI_GRAPH, MPI_CART
       parameter(MPI_GRAPH=1)
       parameter(MPI_CART=2)

       integer MPI_MAX_PROCESSOR_NAME, MPI_MAX_ERROR_STRING
       parameter(MPI_MAX_PROCESSOR_NAME=256)
       parameter(MPI_MAX_ERROR_STRING=256)

       integer MPI_KEYVAL_INVALID
       parameter(MPI_KEYVAL_INVALID=0)
!
! MPI status.
!
       integer MPI_STATUS_SIZE, MPI_SOURCE, MPI_TAG, MPI_ERROR
       parameter(MPI_STATUS_SIZE=4)
       parameter(MPI_SOURCE=2)
       parameter(MPI_TAG=3)
       parameter(MPI_ERROR=4)
!
! Null handles.
!
      integer MPI_COMM_NULL, MPI_DATATYPE_NULL, MPI_ERRHANDLER_NULL
      integer MPI_GROUP_NULL, MPI_REQUEST_NULL
      parameter(MPI_COMM_NULL=0)
      parameter(MPI_DATATYPE_NULL=0)
      parameter(MPI_ERRHANDLER_NULL=0)
      parameter(MPI_GROUP_NULL=0)
      parameter(MPI_REQUEST_NULL=0)
!
! Communicator and group comparisons.
!
      integer MPI_IDENT, MPI_CONGRUENT, MPI_SIMILAR, MPI_UNEQUAL
      parameter(MPI_IDENT=0)
      parameter(MPI_CONGRUENT=1)
      parameter(MPI_SIMILAR=2)
      parameter(MPI_UNEQUAL=3)
!
! Datatype handles and some special constants are put in common blocks.
!
      integer MPI_TAG_UB, MPI_HOST, MPI_IO
      integer MPI_BOTTOM, MPI_INTEGER, MPI_REAL, MPI_DOUBLE_PRECISION
      integer MPI_COMPLEX, MPI_DOUBLE_COMPLEX
      integer MPI_LOGICAL, MPI_CHARACTER, MPI_BYTE
      integer MPI_2INTEGER, MPI_2REAL, MPI_2DOUBLE_PRECISION
      integer MPI_2COMPLEX, MPI_2DOUBLE_COMPLEX
      integer MPI_INTEGER2, MPI_INTEGER4
      integer MPI_REAL4, MPI_REAL8, MPI_UB, MPI_LB
      integer MPI_PACKED, MPI_WTIME_IS_GLOBAL
      integer MPI_COMM_WORLD, MPI_COMM_SELF, MPI_GROUP_EMPTY
      integer MPI_SUM, MPI_MAX, MPI_MIN, MPI_PROD, MPI_LAND, MPI_BAND
      integer MPI_LOR, MPI_BOR, MPI_LXOR, MPI_BXOR, MPI_MINLOC
      integer MPI_MAXLOC, MPI_OP_NULL
      integer MPI_ERRORS_ARE_FATAL, MPI_ERRORS_RETURN

      common /mpipriv/ MPI_BOTTOM, MPI_INTEGER, MPI_REAL
      common /mpipriv/ MPI_DOUBLE_PRECISION, MPI_COMPLEX
      common /mpipriv/ MPI_DOUBLE_COMPLEX
      common /mpipriv/ MPI_LOGICAL, MPI_CHARACTER, MPI_BYTE
      common /mpipriv/ MPI_2INTEGER, MPI_2REAL, MPI_2DOUBLE_PRECISION
      common /mpipriv/ MPI_2COMPLEX, MPI_2DOUBLE_COMPLEX
      common /mpipriv/ MPI_INTEGER2, MPI_INTEGER4, MPI_REAL4
      common /mpipriv/ MPI_REAL8, MPI_UB, MPI_LB
      common /mpipriv/ MPI_COMM_WORLD, MPI_COMM_SELF, MPI_GROUP_EMPTY
      common /mpipriv/ MPI_SUM, MPI_MAX, MPI_MIN, MPI_PROD, MPI_LAND
      common /mpipriv/ MPI_BAND, MPI_LOR, MPI_BOR, MPI_LXOR, MPI_BXOR
      common /mpipriv/ MPI_MINLOC, MPI_MAXLOC, MPI_OP_NULL, MPI_TAG_UB
      common /mpipriv/ MPI_HOST, MPI_IO, MPI_ERRORS_ARE_FATAL
      common /mpipriv/ MPI_ERRORS_RETURN,MPI_PACKED,MPI_WTIME_IS_GLOBAL
!
! Make sure the common block is static.
!
      save /mpipriv/
!
! MPI functions.
!
      double precision MPI_WTIME, MPI_WTICK, PMPI_WTIME, PMPI_WTICK
      external MPI_WTIME, MPI_WTICK, PMPI_WTIME, PMPI_WTICK
!
! The attribute copy/delete functions are symbols that can be passed
! to MPI routines.
!
      external MPI_NULL_COPY_FN, MPI_NULL_DELETE_FN, MPI_DUP_FN
