/*-----------------------------------------------*/
/*       Lingyun Jin  10-12,1998.                */
/*       Jackson state University                */
/*       Computer science Department             */
/*                                               */   
/*       Assignment 3 for CPS-615.               */
/*   Make sure :  Processsor number is 4         */
/*-----------------------------------------------*/

#include  <stdio.h>
#include  <math.h>
#include  <mpi.h>

double sqrt();

double f(double,double );      /* Integral function */

void main(int argc, char *argv[])
{
  int P;                       /* Number of processors */
  int my_rank;                 /* Processor rank       */
  double  a=0.0;               /* left endpoint        */
  double b=1.0;                /* right endpoint       */
  int n=100;                   /* Number of trapezoids */
  double h;                    /* Trapezoid base length */
  
  double start_x; 
  double stop_x;
  double start_y; 
  double stop_y;
  double x ;
  double y;
  
  double local_pi=0.0;         /* integral over local intervals  */
  double total=0.0 ;           /* total integral, initial to 0    */
  int i;
                    

   MPI_Comm grid_comm;
   int dim_size[2];
   int wrap_around[2];
   int reorder=1;
   int coordinates[2];
   int my_grid_rank;
           
  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
  MPI_Comm_size(MPI_COMM_WORLD, &P);
                              
  h=(b-a)/n;                    /* base length is same to all prosess  */

                             
  /*  Use Cartesian topology to give coordianate for 4 processors  */
  /*
           ^
           |
      (0,1)|  ______________________________(1,1)
           | | PROCESS[1,0] | PROCESS[1,1]  |
           | |______________|_______________|
           | | PROCESS[0,0] | PROCESS[0,1]  |
      (0,0)| |______________|_______________|(1,0)
           |----------------------------------------------------> 


 */

  wrap_around[0] = wrap_around[1] = 1;
  dim_size[0]=dim_size[1] = 2;

  MPI_Cart_create(MPI_COMM_WORLD, 2, dim_size, wrap_around,
     reorder, &grid_comm);
  MPI_Comm_rank(grid_comm, &my_grid_rank);
  MPI_Cart_coords(grid_comm, my_grid_rank, 2, coordinates);
 
  start_x = coordinates[1]/2.0; 
  stop_x = coordinates[1]/2.0 + 1.0/2.0;
  start_y = coordinates[0]/2.0;
  stop_y = coordinates[0]/2.0 + 1.0/2.0;
 
 printf("Local processor:%d\n start_x=%f \t start_y= %f\n", my_grid_rank, start_x, start_y);
  for(x=start_x; x < stop_x; x+=h)
    { for(y = start_y; y < stop_y; y+=h)
       local_pi+= h * h *(f(x,y) + f(x,y+h)+ f(x+h,y) + f(x+h,y+h))/4.0;
     }  
     local_pi=local_pi * 16.0;
  printf("local processor:%d has pi= %f\n", my_grid_rank, local_pi);     
          
/* sum the integrals calculated by each process        */
 
MPI_Reduce(&local_pi,&total,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);  
if (my_rank==0)
    {
      printf("-------------------------------------------------\n");
      printf("The computed Pi of the integral for %d grid points is:%25.16e \n",
	     n, sqrt(total));
    }



  MPI_Finalize();
}

/* end of main */



double f(double x, double y)
{
  return (double)1.0/((1.0 + x * x)*(1.0 + y * y));    
 /* compute function and return value */
}



 
 
