/* Written by Siddharth AGarwal */

#include <stdio.h>
#include <math.h>
#include  "mpi.h"

double fun(double x);

int main(int argc, char * argv[])
{
 int rank,nop;   /* No of processors */
 int no = 100;   /* the no of divisons into which the interval 0 to 1 is divided*/
 int root =0, cnt = 1,j;
 double y =0, z = 1;
 double final= 0, integral, x,a;
 double fptr[10];

 /* This is the first function that is called, no other MPI function can be called beforee this */
 MPI_Init(&argc, &argv);
 
 /* Returns the rank of the calling process in the group underlying the communicatator comm. If comm
    ia an inter - communicator,it returns the rank in the local group*/
 MPI_Comm_rank(MPI_COMM_WORLD, &rank);

 /* This function returns the number of processes in the group underlying comm. If comm is an 
    inter-communicator, return the size of the local group. */
 MPI_Comm_size(MPI_COMM_WORLD, &nop);

 MPI_Bcast(&no, cnt, MPI_INT, root, MPI_COMM_WORLD);

 a = (z-y)/no;   /* This calculates the width of the intervals into which the trapezoidal is divided */ 
 for (j= rank+1; j <= no; j+=nop)
 {         
 	x = a*((double)j - 0.5);
        integral+= fun(x);
 }
 integral = a*integral;
 MPI_Gather(&integral, cnt, MPI_DOUBLE, fptr, 1, MPI_DOUBLE, root, MPI_COMM_WORLD);

 if(rank == 0)
 {
   int k;
   for (k = 0; k < nop; k++)
   final = final+fptr[k];
 }

 MPI_Bcast(&final, cnt, MPI_DOUBLE, root, MPI_COMM_WORLD);

 printf("\n Value of Pi calculated by Process%i: %.20f\n", rank, final);

 MPI_Finalize();
 }

 /* This function is used to integrate the function 4/(1 + x*2)*/
 double fun(double x)
 {
 return (4.0/(1.0+x*x));
 }





