#include <stdio.h> 
#include <math.h> 
#include <mpi.h> 

#define N 4

int f(int a,int b); 

main(argc, argv)
int argc;
char *argv[]; 
{ 
  int P,Rank; 
  int i,j,k; 
     
  int x[2],y[2],correlation[2]; 
  int dest,sumcorr, array; 
  int TotalValue=0,TotalSum=0;    
  MPI_Status status; 

    /**********************Initialization*************************/ 
  MPI_Init(&argc,&argv); 
  MPI_Comm_size(MPI_COMM_WORLD,&P); 
  MPI_Comm_rank(MPI_COMM_WORLD,&Rank); 

   
  if (P <= 2)
    {  printf("Please set to higher node.");
    MPI_Finalize();
    }
  else
    { 
      /*******************Setting x's and y's*******************************/ 

      switch(Rank) 
	{ 
	case 0:x[0]=2; x[1]=5; 
	  y[0]=2; y[1]=5; 
	  break; 
	case 1:x[0]=4; x[1]=3; 
	  y[0]=4; y[1]=3; 
	  break; 
	case 2:x[0]=13; x[1]=15; 
	  y[0]=13; y[1]=15; 
	  break; 
	case 3:x[0]=17; x[1]=18; 
	  y[0]=17; y[1]=18; 
	  break; 
	} 

	/********************Processors Computing****************************/ 
      for(k=0; k<P; k++) 
	{ 
	  /* Compute correlations of x's & y's in processor */ 
	  for(j=0; j<2; j++) 
	    for(i=0; i<2; i++) 
	      correlation[i]+=f(x[i],y[j]); 

	  dest=(Rank+1)%P; 
	  sumcorr=(Rank-1+P)%P; 
	  MPI_Sendrecv(&y,2,MPI_DOUBLE,dest,1,&array,2,MPI_DOUBLE, sumcorr,
		       1, MPI_COMM_WORLD, &status); 
       
	} 
      for(i=0; i<2; i++) 
	TotalValue+=correlation[i]; 

      MPI_Reduce(&TotalValue,&TotalSum,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD); 

	/*********************Output*******************************/ 
      for(i=0; i<2; i++) 
	printf("correlation[%d]=%d\n",i+Rank*2,correlation[i]); 
      if(Rank==0) 
	printf("The result=%d\n",TotalSum); 

	/**************Finalization**************************************/ 
      MPI_Finalize(); 
    } 
} 


int f(int a,int b) 
{ 
  return abs(a*a+b*b); 
} 
