#include <stdio.h>
#include <mpi.h>

main(int argc, char *argv[]) 
{
  int myrank, size,left,right;
  int val, sum, tmp;
  MPI_Status recv_status, send_status;
  /* MPI_Request send_request;
 */
  MPI_Request send_request, recv_request;
 
  float fval;

  /* Initialize MPI */
  MPI_Init(&argc, &argv);
  /*Find out my rank and size using MPI_COMM_WORLD */
  MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  printf("Process %d of %d running\n",myrank,size);
  fflush(stdout);

  /* Find out neighbors */
  /* if ((left=(myrank-1)) < 0) left == size - 1;
  */
  left=(myrank-1+size)%size; 
  /* if ((right=(myrank+1)) == size) right = 0;
  */
  right=(myrank+1+size)%size; 

  /* Send and recieve */
  val = myrank;
  fval = (float)myrank;
  sum=0;
  do {
    MPI_Issend(&val,1,MPI_INT,right,99,MPI_COMM_WORLD,&send_request);
    MPI_Recv(&tmp,1,MPI_INT,left,99,MPI_COMM_WORLD,&recv_status);
 
    MPI_Wait(&send_request,&send_status);
 
    /* MPI_Sendrecv( &val, 1, MPI_INT, right, 99, &tmp, 1, MPI_INT, left,
     99, MPI_COMM_WORLD, &recv_status ); */
    val=tmp;
    sum += val;    
  } while(val != myrank);
  /* Print the output message */
  printf("Proc %d sum = %d \n", myrank, sum);
  fflush(stdout);

  /* Exit and finalize MPI */
  MPI_Finalize();
  exit(0);
} /* main */
