#include <stdio.h>
#include <mpi.h>
#include <string.h>


main(int argc, char* argv) {

int rank;   /* rank of process */
int p;      /* number of process */
int tag=0;  /* tag for messages  */
MPI_Status status;  /* return status for receive */

MPI_Request s_req;
MPI_Request r_req;


int source;
int msg[100];
double start,finish,time;

/* Start up MPI */
MPI_Init(&argc, &argv);

/* Find out process rank */
MPI_Comm_rank(MPI_COMM_WORLD, &rank);

/* Find out number of prosess */
MPI_Comm_size(MPI_COMM_WORLD, &p);

printf("Time\n");
fflush(stdout);
start = MPI_Wtime();

   

    MPI_Bcast(msg,100,MPI_INT,0,MPI_COMM_WORLD);

    if(rank != 0) {
       MPI_Isend(msg,100,MPI_INT,0,tag,MPI_COMM_WORLD,&s_req);
       MPI_Wait(&s_req,&status);
    } /* end of if rank */
    else {
       for (source=1;source<p;source++){
         MPI_Irecv(msg,100,MPI_INT,source,tag,MPI_COMM_WORLD,&r_req);
         MPI_Wait(&r_req,&status);
       } /* end of for */   
   } /* end of if else */
finish = MPI_Wtime();
time = finish - start;

printf("rank: %d time: %f\n",rank,time/200.0);
fflush(stdout);
      
/* Shut down MPI */
MPI_Finalize();
exit(0);
} /* end of main */