#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mpi.h"

double pi = 3.141592654;
main(int argc, char* argv[]) {
    int my_rank;        /* rank of process */
    int p;              /* number of process */
    int source;         /* rank of sender */
    int dest;           /* rank of receiver */
    int tag=0;          /* tag of message  */
    char message[100];  /* storage for message */
    MPI_Status status;  /* return status for receive */
    double integral;
    double f(), Intergrat();
    int local_n;
    int nintervals=128;


    /* Start up MPI */
    MPI_Init(&argc, &argv);

    /* Find out process rank */
    MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);

    /* Find out number of process */
    MPI_Comm_size(MPI_COMM_WORLD, &p);

   
    local_n = nintervals/p; 
    integral = Intergrat(local_n);


    if(my_rank == 0) {
        for (source=1;source<p;source++) {
            MPI_Recv(&integral,1,MPI_DOUBLE,source,tag,
                     MPI_COMM_WORLD,&status);
            printf("Process %d contribution = %f\n",source,integral);

        } /* for */
    } else {
         dest=0;
         MPI_Send(&integral,1,MPI_DOUBLE,dest,tag,MPI_COMM_WORLD);
    } 

    /* Shut down MPI */
    MPI_Finalize();
    exit(0);
} /* main */

double Intergrat(int local_n) { 

    double deltax, fleftx, frightx, rightx;
    int  i;
    double integral=0.0;
    deltax = (0.5*pi)/(double)local_n;

    fleftx = f(0.0);
    for (i=1;i<=local_n;i++) {
         rightx = deltax * (double)i;
         frightx = f(rightx);
         integral += deltax * 0.5 * (fleftx + frightx);
         fleftx = frightx;
    } /* for */
    return(integral);
} /* intergration */

double f(double x) {
   double y;
   y=cos(x);
   return (1.0/sqrt(1.0 - 0.5*y*y));
} /* f() */
