/******************************************************************
 * Qiang Zheng,
 * ECS Dept, Syracuse Univ. Nov. 10, 1999
 * for CIS 615 class, Spring, 2000,
 * Instructor: Geoffrey C Fox, Nancy McCracken
 * O.S.: Solaris  Environment: VPL
 * Libraries: mpilib.a
 *
 * Purpose:     A program to experiment with point-to-point
 *              communications. 
 *
 * Author:      CPS615 - Spring 2000
 *
 *****************************************************************/

#include	<stdio.h>
#include	<mpi.h>

float buffer[100000];

#define ROOT 0
#define ping 101  /* Tag for SEND */
#define pong 101  /* Tag for RECEIVE */

void main ( int argc, char *argv[] )
{
     int rank, size , procNum;

     MPI_Init(&argc, &argv);
     MPI_Comm_rank( MPI_COMM_WORLD, &rank );
     MPI_Comm_size( MPI_COMM_WORLD, &procNum );

     if (rank == ROOT )
       master( procNum );
     else
       slave( );

     MPI_Finalize();
}

master( int procNum )
{
  int i, j, length, destId, srcId ;
  double start, finish, time;
  extern float buffer[100000];
  MPI_Status status;

  printf("Length\tTotal Time\tTransfer Rate\n");
  for ( length = 1; length<=100000; length+=1000 ) { 
    start = MPI_Wtime();
    for ( i=1;i<=100;i++ ){
      for( j=1; j<procNum; j++ ) {
        MPI_Ssend(buffer, length, MPI_FLOAT, j, ping,
          MPI_COMM_WORLD);
        MPI_Recv(buffer, length, MPI_FLOAT, j, pong,
          MPI_COMM_WORLD, &status);
      }
    }

    finish = MPI_Wtime();
    time = finish - start;
 	printf("%d\t%f\t%f\n", length, time/200., (float)(2 * 8 * 100 * length)/time);
  }
}

slave( )
{
  int i;
  MPI_Status status;
  extern float buffer[100000];
  int length;

  for (length = 1; length <= 100000; length += 1000) { 
    for (i = 1; i <= 100; i++) {
      MPI_Recv(buffer, length, MPI_FLOAT, ROOT, ping, MPI_COMM_WORLD, &status);
      MPI_Ssend(buffer, length, MPI_FLOAT, ROOT, pong, MPI_COMM_WORLD);
    }
  }
}
