#include "mpi.h"
#include <stdio.h>

#define ROOT 0
#define TAG  0

main( int argc, char *argv[] ) 
{
  int token=5, myRank, numProc, i;
  double start, finish, elaps;
  MPI_Status * stat;
  MPI_Request * recv_req;
  
  MPI_Init( &argc, &argv );
  MPI_Comm_rank( MPI_COMM_WORLD, &myRank );
  MPI_Comm_size( MPI_COMM_WORLD, &numProc );
  start=MPI_Wtime();

  MPI_Bcast( &token, 1, MPI_INT, ROOT , MPI_COMM_WORLD );
  if( myRank==ROOT ) {

    recv_req=( MPI_Request * ) malloc ( ( numProc-1 )*sizeof( MPI_Request ) );
    stat=( MPI_Status * ) malloc ( ( numProc-1 )*sizeof( MPI_Status ) );

    for( i = 1; i < numProc ; i++ ) {
      MPI_Irecv( &token, 1, MPI_INT, i, TAG, MPI_COMM_WORLD, recv_req+(i-1) );
    }

    for( i = 1; i < numProc ; i++ ) {
      MPI_Wait( recv_req+( i-1 ), stat+(i-1) );
    }
  } else {
    MPI_Send( &token, 1, MPI_INT, ROOT, TAG, MPI_COMM_WORLD );
  }

  elaps=MPI_Wtime()-start;

  if ( myRank==ROOT ) {
    printf( "Time with Broadcast = %f\n", elaps );

    free( recv_req );
    free( stat );
  }

  MPI_Finalize();
}
