#include "mpi.h"
#include <stdio.h>

#define ROOT 0
#define TAG  0
#define LENGTH 16

main( int argc, char *argv[] ) 
{
  int token=5, myId, numProc, i,j;
  double start, finish, elaps;
  int * globalArray;
  int * localArray;

  MPI_Init( &argc, &argv );
  MPI_Comm_rank( MPI_COMM_WORLD, &myId );
  MPI_Comm_size( MPI_COMM_WORLD, &numProc );
  start=MPI_Wtime();

  if ( myId==ROOT ) {
    globalArray=( int * )malloc( LENGTH*numProc*sizeof( int ) );
    printf("The original Array is:\n");

    for( i=0; i<numProc; i++ ) {
      for( j=0; j<LENGTH; j++) {
        globalArray[ i*LENGTH+j ]=j;
        printf("%d ",globalArray[ i*LENGTH+j ]);
      }
      printf("\n");
    }
  }

  localArray=(int *)malloc( LENGTH*sizeof( int ) );

  MPI_Scatter( globalArray, LENGTH, MPI_INT, localArray
    , LENGTH, MPI_INT, ROOT, MPI_COMM_WORLD );

  for( i=0; i<LENGTH; i++ ) {
    localArray[ i ]=localArray[ i ]<<1;
  }

  MPI_Gather( localArray, LENGTH, MPI_INT, globalArray
    , LENGTH, MPI_INT, ROOT, MPI_COMM_WORLD );

  elaps=MPI_Wtime()-start;

  if ( myId==ROOT ) {
    printf("The result Array is:\n");
    for( i=0; i<numProc; i++ ) {
      for( j=0; j<LENGTH; j++) {
        printf("%d ",globalArray[ i*LENGTH+j ]);
      }
      printf("\n");
    }
    free( globalArray );
    printf("\n\nElaps time is:%f seconds\n\n", elaps);
  }

  free( localArray );

  MPI_Finalize();
}
