#include <string.h>
#include <malloc.h>
#include <stdio.h>
#include "db.h"

/* allocate memory for record */
static RECORD * newRec( int n )
{
  int * dList;
  RECORD * rec;

  dList = ( int * ) malloc ( n*sizeof( int ) );
  rec = ( RECORD * )malloc( sizeof( RECORD ) );
  rec->itemList = dList;

  return rec;
}

/* allocate memory for database */
static DBASE * newDb( int recs, int flds )
{
  RECORD ** rList;
  DBASE * db;

  rList=( RECORD ** )malloc( recs*sizeof( RECORD * ) );
  db = ( DBASE * ) malloc( sizeof ( DBASE ) );
  db->table = rList;
  db->numOfRecs=recs;
  db->numOfItems=flds;

  return ( db );
}

/* insert a record in database at specified offset */
static void insertRecAt( DBASE * db, int offset, RECORD * rec )
{
  RECORD ** p;

  p=db->table+offset;
  *p=rec;
}

/* remove from memory */
void delRec( RECORD * p )
{
  free(p->itemList);
  free(p);
}

void delDb( DBASE * db )
{
  RECORD **p;

  p=db->table+db->numOfRecs;

  while ( --p!=db->table ) delRec( *p );

  free( db->table );
  free( db );
}

/* read from file */
DBASE * readFrom( FILE * dbFile )
{
  DBASE * db;
  RECORD **tblp, *recp;
  FILE * fp;
  int rowNum=0, colNum=0, i=0, j=0;
  char line[1024];
  char *cp , *cp0;
  register int c;

  /* determine the length and the width of a table */
  fp=dbFile;

  /* assumes the number of lines in file is the number of records */
  c = getc(fp);
  while ( c !=EOF ) {
    rowNum = ( c=='\n'? rowNum+1 : rowNum );
    c=getc( fp );
  }

  /* finding out the column number */
  rewind( fp );
  do {
    c=getc( fp );
    if( isspace( c ) ) colNum++;
  } while ( c!='\n'&&c!=NULL );

  db = newDb( rowNum,colNum );

  /* put data to the structure table */
  rewind( fp );
  for ( i=0; i<rowNum; i++ ) {

    recp=newRec(colNum-1);

    cp=fgets( line, 1024, fp );
    cp0=cp;

    cp0=strtok( cp," " );
    recp->transId= atoi( cp0 );

    for ( j=0; j<colNum-1; j++ ) {
      cp0=strtok( NULL," " );
      recp->itemList[j]=atoi( cp0 );
    }
    insertRecAt( db, i, recp );

  }
  return db;
}

void report( DBASE * db )
{
  int i, j;

  for (i=0; i<db->numOfRecs; i++ ) {
    printf("\n");
    printf("transaction ID: %d\t",( ( db->table )[i] )->transId );
    for (j=0; j<db->numOfItems; j++ )
      printf("%d\t", DATAITEM(db->table,i,j) );
  }
}

int sumOfField( DBASE * db, int fieldId, int recNum )
{
  int sum=0;
  while ( recNum-->0 ) {
    sum+=DATAITEM( db->table,recNum,fieldId );
  }
}
