#include<pnm.h>
#include<stdio.h>

int main ( int argc, char *argv[] )
{
  xel **image, **newImage, **temp0, **temp1;
  xel *oldXel, *newXel;
  xelval maxval, pVal;
  pixval gVal, rVal, bVal;
  char *oldFname, *newFname, *p;

  FILE *origF = NULL, *destF = NULL ;
  int colNum, rowNum, format, colCount, rowCount;


  pnm_init( &argc, argv );

  /* get file pointer */
  origF = fopen( argv[ 1 ], "r");

  if ( origF==NULL ) {
    printf( "No such file %s or permission denied. \n", argv[ 1 ] );
    exit( 1 );
  }

  oldFname = argv[ 1 ];

  newFname = ( char * ) calloc( strlen( oldFname )+3, sizeof( char ) );

  p = newFname;

  while( *oldFname != '.' ) {
    *p++ = *oldFname++;
  }

  *p++ = '_'; *p++ = 's';

  while( *oldFname != '\0' ) {
    *p++ = *oldFname++;
  }

  *p++ = '\0';

  destF = fopen( newFname, "w");

  image = pnm_readpnm( origF, &colNum, &rowNum, &maxval, &format);
  newImage = ( xel ** )calloc( rowNum, sizeof( xel* ) );

  switch ( PNM_FORMAT_TYPE( format ) ) {
    case PPM_TYPE:
      for( rowCount=0, temp0=image+rowNum-1, temp1=newImage;
        rowCount<rowNum;
        rowCount++, temp0--, temp1++ ) {
        *temp1 = ( xel * )calloc( colNum, sizeof( xel ) );
        /* *temp1 = memcpy( *temp1, *temp0, colNum*sizeof( xel ) ); */

        for ( colCount=0, oldXel = *temp0, newXel = *temp1;
              colCount<colNum;
              colCount++, oldXel++, newXel++ ) {
          gVal = PPM_GETG( *oldXel );
          rVal = PPM_GETR( *oldXel );
          bVal = PPM_GETB( *oldXel );

          PPM_ASSIGN( *newXel, rVal, gVal, bVal );
        }
      }
      break;
    case PGM_TYPE:
    case PBM_TYPE:
      for( rowCount=0, temp0=image+rowNum-1, temp1=newImage;
        rowCount<rowNum;
        rowCount++, temp0--, temp1++ ) {
        *temp1 = ( xel * )calloc( colNum, sizeof( xel ) );

        for ( colCount=0, oldXel = *temp0, newXel = *temp1;
              colCount<colNum;
              colCount++, oldXel++, newXel++ ) {
          pVal = PNM_GET1( *oldXel );

          PNM_ASSIGN1( *newXel, pVal );
        }
      }
      /* do pgm stuff and pbm stuff */
      break;
    default:
      break;
  }

  pnm_writepnm( destF, newImage, colNum, rowNum, maxval, format, 0 );

  pnm_freearray( image, rowNum );
  pnm_freearray( newImage, rowNum );
}
