/********************************************/
/*     Assignement 2                        */
/*     Written by:                          */
/*     Srinivasa Rao Chava                  */
/*     Computation of PI Using MPI_Gather() */
/********************************************/

#include <stdio.h>
#include "mpi.h"
main(int argc, char** argv){
int my_rank;  /*process rank*/
int p; /*number of processors*/
int i;
float a=0.0;          /* left end point*/
float b=1.0;          /* right end point*/
int n=1024;           /*number of trapezoids*/
float h;              /* trapezoid base length*/
float local_a;        /*left end point of my process*/
float local_b;        /*right end point of my process*/
int local_n;          /* Number of trapezoids for my calculation*/
float integral;       /* integral over my interval*/
float rbuf[];         /* buffer to store the integral values of each process*/ 
float total = 0;      /* total integral i.e value of pi*/
float x=0.0;
int c;

  /* function proto type for calculating local integral*/
float trap(float local_a, float local_b, int local_n, float h);

  /* Starting up MPI*/
MPI_Init(&argc,&argv);

  /*get my process rank*/
MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);

  /*find out how many processes are being used*/
MPI_Comm_size(MPI_COMM_WORLD, &p);

  /* if n is not divisible by p, (x-c)won't be zero.*/
 x = (float)n/p;
 c= n/p;

  /* Making n is evenly divisible by p to avoid fraction in intervals 
   distributed among processors */
 if((x-c)==0)
    n=1024;
  else
    n=p*c;
  
 h=(b-a)/n;        /*h is same for all prcesses*/
 local_n = n/p;    /* number of trapezoids for each process*/

  /* Broadcasting the number of intervals to integreted at each 
   processors to all the processors */
MPI_Bcast(&local_n,1,MPI_INT,0,MPI_COMM_WORLD);

  /* Length of each process's interval of integration= local_n*h */
  /* So my inerval starts at:*/
local_a = a + my_rank*local_n*h;
local_b= local_a + local_n*h;

integral= trap(local_a,local_b,local_n,h);

  /*Gathering the integrals calculated at different processors 
    and storing it in buffer rbuf located at process zero*/

MPI_Gather(&integral,1,MPI_FLOAT,rbuf,1,MPI_FLOAT,0,MPI_COMM_WORLD);

  /* Totalling all the integrals collected at zero and printing 
   PI value */
   
if(my_rank ==0) 
  {  for(i=0;i<p;++i) 
     total = total + rbuf[i];
     printf("The value of pi with  %d  trapezoids is:\n",n);
     printf("%.16f\n",total);
         }

  /* Broadcasting the calculated PI value to all the processors */ 

 /*.........The following broadcast is not needed. Unless those guys
   (the slaves) need to do further work, why they should be notified
    about the final result?   .... Anyway, broadcats are pretty
    expensive so better be avoided if possible.    */

/* MPI_Bcast(&total,1,MPI_FLOAT,0,MPI_COMM_WORLD); */
     
  /* shut down MpI*/
MPI_Finalize();
 
}/* main*/


   /* Function trap() definition*/
float trap(float local_a,float local_b,int local_n, float h)
     {
        float integral;
        float x;
        int i;

        float f(float x);
        integral=(f(local_a)+f(local_b))/2.0;
        x=local_a;
        for(i=1; i<=local_n-1;i++)
              {
                x=x+h;
                integral= integral+f(x);
                       }
        integral=integral*h;
        return integral;
       }/* trap*/


   /* function f() defintion*/
float f(float x)
       {
          float return_val;
          return_val =4.0/( 1 + x*x);
          return return_val;
             }
