/*
**
**  Han-Ku Lee
** 
**  Assignment2 - CPS615 
**
*/

#include <stdio.h>
#include <mpi.h>
#include <math.h>

int main(int argc, char *argv[])
{
  /* Integer, Double type variable declaration */
  int myProcessId, numOfProcesses, i;
  int n = 50;                            /* Fixed number of Intervals */
  double PI = 3.14159265358979323842643; /* Approximated original PI value */
  double receiveBuffer[8];
  double myPI, pi, k, sum, x, a;
  
  /* Initialize MPI functions */ 
  MPI_Init(&argc, &argv);

  /* To know how many processes are involved */  
  MPI_Comm_size(MPI_COMM_WORLD, &numOfProcesses);
  
  /* In order for a process to find out its rank */
  MPI_Comm_rank(MPI_COMM_WORLD, &myProcessId);

  /* Send a copy of data in message on the process
     with rank root to each process */
  MPI_Bcast(&n, 1, MPI_INT, 0, MPI_COMM_WORLD);
    
  /* From now on it is the formula to get the approx. value of pi */
  k = 1.0 /(double) n;
  
  sum = 0.0;
  
  for (i=myProcessId+1; i<=n; i+=numOfProcesses){
    x = k *((double)i - 0.5);
    sum += 4.0/(1.0 + x*x);
  }
  myPI = k * sum;

  /* Collect data refernced by myPI from each process  */
  MPI_Gather(&myPI, 1, MPI_DOUBLE, &receiveBuffer ,1, MPI_DOUBLE, 0, MPI_COMM_WORLD);  

  /* if my process is the root */
  if (myProcessId == 0){

    /* add the values in the receiveBuffer to get pi */
    for(i=0, pi=0; i<numOfProcesses; i++){
      pi += receiveBuffer[i];
    }


    printf("pi is approximately %.16f, and the Error is %.16f\n", 
            pi, fabs(pi - PI));
  }

#if 1
  /* Broadcast again to each process */
  MPI_Bcast(&pi, 1, MPI_DOUBLE, 0, MPI_COMM_WORLD);
  printf("my id:%d, pi:%f\n", myProcessId, pi);
#endif

  /* Clean up uesed MPI library */
  MPI_Finalize();
}
