        PROGRAM pingpong

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C Purpose:    A program to try point-to-point communications.
C
C No. of Nodes:    2
C
C Author:   CPS615 - Spring 2000
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      IMPLICIT NONE

      INCLUDE "mpif.h"

      INTEGER proc_A
      PARAMETER(proc_A=0)		

      INTEGER proc_B
      PARAMETER(proc_B=1)		

      INTEGER ierror, rank, size

      CALL MPI_INIT(ierror)

      CALL MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierror)

      IF (rank .EQ. proc_A) THEN
           CALL processor_A()
      ELSE IF (rank .EQ. proc_B) THEN
           CALL processor_B()
      END IF

      CALL MPI_FINALIZE(ierror)

      STOP
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE processor_A()
      IMPLICIT NONE

      INCLUDE "mpif.h"

      INTEGER ping
      PARAMETER(ping=101)
      INTEGER pong
      PARAMETER(pong=101)

      INTEGER proc_A
      PARAMETER(proc_A=0)		

      INTEGER proc_B
      PARAMETER(proc_B=1)		

      INTEGER i, ierror
      INTEGER status(MPI_STATUS_SIZE)

      DOUBLE PRECISION start, finish, time

      COMMON /data/ buffer(100000)
      REAL buffer

      INTEGER length

      DO length = 10000, 100000, 10000

           start = MPI_WTIME()

           DO i = 1,100

	        CALL MPI_SSEND(buffer, length, MPI_REAL,
     $                   proc_B, ping, MPI_COMM_WORLD, ierror)

                CALL MPI_RECV(buffer, length, MPI_REAL,
     $                   proc_B, pong, MPI_COMM_WORLD,
     $                   status, ierror)

           END DO

      finish = MPI_WTIME()

      time = finish - start

C     WRITE(*,*) 'Time taken = ', time, ' seconds'

C     WRITE(*,*) 'Bandwidth = ', REAL(2 * 4 * 100 * length)/time

      PRINT *, 'Message Length = ', length
      PRINT *, 'Average Communication Time (over & back) = ', time/100.
      PRINT *, 'Bytes Moved Per Second = ', 
     $          REAL(2 * 4 * 100 * length)/time
      PRINT *, ' '

      END DO

      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE processor_B()
      IMPLICIT NONE

      INCLUDE "mpif.h"

      INTEGER ping
      PARAMETER(ping=101)

      INTEGER pong
      PARAMETER(pong=101)

      INTEGER proc_A
      PARAMETER(proc_A=0)		

      INTEGER proc_B
      PARAMETER(proc_B=1)		

      INTEGER i, ierror
      INTEGER status(MPI_STATUS_SIZE)

      DOUBLE PRECISION start, finish, time

      COMMON /data/ buffer(100000)
      REAL buffer

      INTEGER length

      DO length = 10000, 100000, 10000

C     start = MPI_WTIME()

           DO i = 1,100

                CALL MPI_RECV(buffer, length, MPI_REAL,
     $                   proc_A, ping, MPI_COMM_WORLD,
     $                   status, ierror)

                CALL MPI_SSEND(buffer, length, MPI_REAL,
     $                   proc_A, pong, MPI_COMM_WORLD, ierror)

           END DO

C      finish = MPI_WTIME()

C      time = finish - start

C     PRINT *, "Time taken = ", time, " seconds"

C     WRITE(*,*) 'Time taken = ', time, ' seconds'

      END DO

      RETURN
      END
