      PROGRAM ASSIGNMENT2
      INCLUDE 'mpif.h'
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c This program computes the approximate value of the integral of the
c function dx/(sqrt(1-(cos^2 x)/2)) over the interval 0 to pi/2.
c The program currently divides this interval into 128 subintervals
c and computes the value using the trapizodal approximation technique.
c To adjust computation interval or the number of subintervals,
c change the variables begin, end, and/or tnintervals below.
c --------------------Rebecca Fahey-------CPS 615----------------------
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      Integer           tnintervals, i, ierr, size, rank
      Integer           myintervals, remain, k, left
      Integer           status(MPI_STATUS_SIZE)

      Double Precision  deltax, integral, fleftx, frightx, rightx, pi
      Double Precision  total, begin, end, f
      

c Initializing some variables/constants.
      pi=acos(-1.)
      integral=0.0

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c The settings in this block can be adjusted if desired.
c
c Setting the left point of the interval of integration.
      begin=0.0
c Setting the right point of the interval of integration.
      end=0.5*pi
c Setting the number of integration subintervals.  
      tnintervals=128
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c Initialzing MPI and obtaining the process no. and the no. of processes.
      call MPI_INIT(ierr)
      call MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)
      call MPI_COMM_SIZE(MPI_COMM_WORLD, size, ierr)
     
c Setting the width of the subintervals.
      deltax=(end-begin)/tnintervals

c Determining the number of intervals to be computed by each process
      myintervals=tnintervals/size
      remain=tnintervals-(myintervals*size)

c Dividing up the remaining intervals among the processes
      left=rank*myintervals+1
      do i=1,remain
         if(rank .eq. i-1) then
            myintervals=myintervals+1
         elseif (rank .ge. i)then
            left=left+1
         endif
      enddo

c Setting the left most function value
      fleftx=f(deltax*(left-1))

c Calculating the areas
      do i=left, left+myintervals-1
         rightx=deltax*i
         frightx=f(rightx)
         integral=integral+deltax*.5*(fleftx+frightx)
         fleftx=frightx
      end do

c Performing a reduction on the areas in integral
      if (rank .ne. 0) then
         call MPI_SEND(integral,1,MPI_DOUBLE_PRECISION,0,1,
     $                MPI_COMM_WORLD,ierr)
      else
         print *,'Process 0 contributed ', integral
         total=integral
         do i=1, size-1
            call MPI_RECV(integral,1,MPI_DOUBLE_PRECISION,i,1,
     $                   MPI_COMM_WORLD,status,ierr)
             print *,'Process',i,' contributed',integral
             total=total+integral
         enddo
      endif

c The above reduction should be implemented using an MPI_REDUCE.
c Using MPI_REDUCE would allow for the incorporation of error checking
c and a clean abort if a communication error occurred.

c Printing final answer
      if (rank .eq. 0) then
      print *,'The total value of the integral is', total
      endif

      call MPI_FINALIZE(ierr)
      end

c Below is the function being integrated.  The function can be
c adjusted if desired.
      function f(x)

          double precision  x, y, f

          y=cos(x)
          f=(1.0/sqrt(1.0-0.5*y*y))
      return
      end
